<template>
  <div>
    <RouterView v-if="moduleIsReady" />
    <b-row v-else align-h="center" class="my-4">
      <b-spinner variant="primary" />
    </b-row>
  </div>
</template>

<script lang="ts">
// import the project store
import useProjectStore from "@/modules/project/store";
// import the resource store
import useResourceStore from "@/modules/resource/store";
import type { ProjectDto } from "@coscine/api-client/dist/types/Coscine.Api";

export default defineComponent({
  setup() {
    const projectStore = useProjectStore();
    const resourceStore = useResourceStore();

    return { projectStore, resourceStore };
  },

  computed: {
    moduleIsReady(): boolean {
      return true;
    },
    project(): ProjectDto | null {
      return this.projectStore.currentProject;
    },
  },

  created() {
    this.initialize();
  },

  methods: {
    async initialize() {
      // Load All Projects if not present
      if (this.projectStore.allProjects === null) {
        this.projectStore.retrieveAllProjects();
      }
      // Load Resources for the project if not present
      /*if (this.projectStore.currentResources === null) {
        await this.resourceStore.retrieveAllResources();
      }*/
      // Load list of all Resource Types if not present
      if (this.resourceStore.resourceTypes === null) {
        await this.resourceStore.retrieveAllResourceTypesInformation();
      }
    },
  },
});
</script>
